// parethesis.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stack>
#include <iostream>
#include <string>

int _tmain(int argc, _TCHAR* argv[])
{
	std::string input;
	std::stack<char> s;
	char c;
	int N;

	std::getline(std::cin, input, '\n');

	std::string::iterator itr;
	for (itr=input.begin(); itr!=input.end(); ++itr)
	{	
		switch (*itr)
		{
			case '(' :	
				s.push('(');
				std::cout << *itr;;
				break;
			case ')' :	
				if (!s.empty() && s.top() == '('){ // a match
				   std::cout << ')';               // so print o.w. implicit remove
				   s.pop();
				}
				break;
			default :
				std::cout << *itr;;
		}
	}

	while (!s.empty())
	{
		if (s.top() == '(')
		{
			std::cout << ')';
		}
		s.pop();
	}
	std::cin >> N;

	return 0;
}

